﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WindowsFormsApp1
{
    public class Solution
    {
        // Метод для поиска максимального значения
        public static int[] getMax(int[,] matrix, int matixSize)
        {
            int maxValue = matrix[0, 0];
            int[] indexesMaxValue = new int[2];

            indexesMaxValue[0] = 0;
            indexesMaxValue[1] = 0;

            for (int i = 0; i < matixSize; i++)
            {
                for (int j = 0; j < matixSize; j++)
                {
                    if (matrix[i, j] > maxValue)
                    {
                        maxValue = matrix[i, j];
                        indexesMaxValue[0] = i;
                        indexesMaxValue[1] = j;
                    }
                }
            }

            return indexesMaxValue;
        }

        // Метод для поиска минимального значения
        public static int[,] getMin(int[,] matrix, int matrixSize)
        {
            int[] indexesMaxValue = new int[3];
            int[,] indexesMinValue = new int[matrixSize + matrixSize - 1, 2];

            int iMax = indexesMaxValue[0];
            int jMax = indexesMaxValue[1];

            for (int k = 0; k < matrixSize; k++)
            {
                indexesMaxValue = getMax(matrix, matrixSize);

                int minValue = matrix[indexesMaxValue[0], indexesMaxValue[1]];

                indexesMinValue[k, 0] = iMax;
                indexesMinValue[k, 1] = jMax;

                for (int i = 0; i < matrixSize; i++)
                {
                    for (int j = 0; j < matrixSize; j++)
                    {
                        if (matrix[i, j] < minValue)
                        {
                            bool flag = true;

                            for (int z = 0; z < k; z++)
                            {
                                if (i == indexesMinValue[z, 0] || j == indexesMinValue[z, 1])
                                {
                                    flag = false;
                                    break;
                                }
                            }

                            if (flag)
                            {
                                minValue = matrix[i, j];
                                indexesMinValue[k, 0] = i;
                                indexesMinValue[k, 1] = j;
                            }

                        }
                    }
                }
                matrix[indexesMinValue[k, 0], indexesMinValue[k, 1]] += 100;
            }

            for (int k = matrixSize; k < 2 * matrixSize - 1; k++)
            {
                indexesMaxValue = getMax(matrix, matrixSize);

                int minValue = matrix[indexesMaxValue[0], indexesMaxValue[1]];

                indexesMinValue[k, 0] = iMax;
                indexesMinValue[k, 1] = jMax;

                for (int i = 0; i < matrixSize; i++)
                {
                    for (int j = 0; j < matrixSize; j++)
                    {
                        if (matrix[i, j] < minValue)
                        {
                            minValue = matrix[i, j];
                            indexesMinValue[k, 0] = i;
                            indexesMinValue[k, 1] = j;

                        }
                    }
                }

                matrix[indexesMinValue[k, 0], indexesMinValue[k, 1]] += 100;
            }
            return indexesMinValue;
        }

        // Метод для вычисления потенциалов
        public static int[] calcPots(int[,] matrix, int matrixSize, int[,] minValues)
        {
            int[] potentialsStroka = new int[matrixSize];
            int[] potentStolbes = new int[matrixSize];

            int[,] newMatrix = new int[matrixSize, matrixSize];



            for (int i = 0; i < matrixSize; i++)
            {
                for (int j = 0; j < matrixSize; j++)
                {
                    newMatrix[i, j] = matrix[j, i];
                }
            }

            for (int i = 0; i < matrixSize; i++)
            {
                potentialsStroka[i] = -1;
                potentStolbes[i] = -1;
            }

            potentialsStroka[0] = 0;

            for (int z = 0; z < matrixSize * matrixSize; z++)
            {
                for (int i = 0; i < matrixSize; i++)
                {
                    for (int j = 0; j < matrixSize; j++)
                    {
                        for (int k = 0; k < 2 * matrixSize - 1; k++)
                        {
                            if (j == minValues[k, 0] && i == minValues[k, 1])
                            {
                                if (potentialsStroka[j] != -1) potentStolbes[i] = newMatrix[i, j] - potentialsStroka[j];
                                if (potentStolbes[i] != -1) potentialsStroka[j] = newMatrix[i, j] - potentStolbes[i];
                            }
                        }
                    }
                }

            }

            int[] potentials = new int[2 * matrixSize];

            for (int i = 0; i < matrixSize; i++)
            {
                potentials[i] = potentialsStroka[i]; 
                potentials[i + matrixSize] = potentStolbes[i]; 
            }
            return potentials;
        }

        // Метод для вычисления дельт
        public static int[] calcDelta(int[,] matrix, int[,] minValues, int matrixSize, int[] potentials)
        {
            int[] deltaValues = new int[(matrixSize * matrixSize) - (2 * matrixSize - 1)];
            int deltaValuesCount = 0;

            int[] potentialStroka = new int[matrixSize];
            int[] potentialStolbes = new int[matrixSize];

            for (int i = 0; i < matrixSize; i++)
            {
                potentialStroka[i] = potentials[i];
                potentialStolbes[i] = potentials[i + matrixSize];
            }

            int[,] newMatrix = new int[matrixSize, matrixSize];

            for (int i = 0; i < matrixSize; i++)
            {
                for (int j = 0; j < matrixSize; j++)
                {
                    newMatrix[i, j] = matrix[j, i];
                }
            }

            int[,] secondMatrix = new int[matrixSize, matrixSize];

            for (int i = 0; i < matrixSize; i++)
            {
                for (int j = 0; j < matrixSize; j++)
                {
                    secondMatrix[i, j] = matrix[j, i];
                }
            }


            for (int i = 0; i < matrixSize; i++)
            {
                for (int j = 0; j < matrixSize; j++)
                {
                    for (int k = 0; k < 2 * matrixSize - 1; k++)
                    {
                        if (i == minValues[k, 0] && j == minValues[k, 1])
                        {
                            newMatrix[j, i] = 0;
                        }
                    }
                }
            }
            for (int i = 0; i < matrixSize; i++)
            {
                for (int j = 0; j < matrixSize; j++)
                {
                    if (newMatrix[i, j] != 0)
                    {
                        deltaValues[deltaValuesCount] = potentialStolbes[i] + potentialStroka[j] - secondMatrix[i, j];
                        deltaValuesCount++;

                        if (deltaValuesCount >= (matrixSize * matrixSize) - (2 * matrixSize - 1))
                            return deltaValues;

                    }
                }
            }

            return deltaValues;
        }


    }
}
